<?php

namespace Lc\SovBundle\Factory\Ticket;

use App\Entity\Ticket\Ticket;
use Lc\SovBundle\Factory\AbstractFactory;
use Lc\SovBundle\Model\Ticket\TicketInterface;

class TicketFactory extends AbstractFactory implements TicketFactoryInterface
{
    protected TicketMessageFactoryInterface $ticketMessageFactory;

    public function __construct(TicketMessageFactoryInterface $ticketMessageFactory)
    {
        $this->ticketMessageFactory = $ticketMessageFactory;
    }

    public function create(): TicketInterface
    {
        $ticket = new Ticket();

        $ticketMessage = $this->ticketMessageFactory->create() ;
        $ticket->addTicketMessage($ticketMessage) ;

        return $ticket;
    }

}
